﻿//Basic Stream Sensor Data Ardunio to App Inventor App 10/09/2019 13:06:09

//include libs
#include "SI114.h"

unsigned long CurrentMillis;
unsigned long PreviousMillis = 1;
unsigned long IntervalMillis = 2000;
int test_vis;
int test_ir;

const int portForSI114 = 0; //for SI114 JJ
PortI2C myBus(portForSI114);
PulsePlug pulse(myBus);

void setup()
{
         initPulseSensor();
         Serial.begin(9600);
}

void loop()
{
            CurrentMillis = millis();

         if((CurrentMillis - PreviousMillis) >= IntervalMillis) 
         {
                PreviousMillis = CurrentMillis;
         
                test_vis = pulse.getReg(PulsePlug::ALS_VIS_DATA0) + 256 * pulse.getReg(PulsePlug::ALS_VIS_DATA1);
                 test_ir = pulse.getReg(PulsePlug::ALS_IR_DATA0) + 256 * pulse.getReg(PulsePlug::ALS_IR_DATA1);
         
                Serial.print("V");
                Serial.print(test_vis);
                Serial.print(",");
                Serial.print("R");
                Serial.print(test_ir);
                Serial.println();       
         }
}

void initPulseSensor()
{
         pulse.setReg(PulsePlug::HW_KEY, 0x17);
         
         //Serial.print("PART: ");
         //Serial.print(pulse.getReg(PulsePlug::PART_ID));
         //Serial.print(" REV: ");
         //Serial.print(pulse.getReg(PulsePlug::REV_ID));
         //Serial.print(" SEQ: ");
         //Serial.println(pulse.getReg(PulsePlug::SEQ_ID));
         
           pulse.setReg(PulsePlug::INT_CFG, 0x03);                 //turn on interrupts                                                            
         //pulse.setReg(PulsePlug::IRQ_ENABLE, 0x10);              //turn on interrupt on PS3
           pulse.setReg(PulsePlug::IRQ_ENABLE, 0x0F);              //turn on interrupt on PS12 JJ
         //pulse.setReg(PulsePlug::IRQ_MODE2, 0x01);               //interrupt on ps3 measurement
           pulse.setReg(PulsePlug::IRQ_MODE1, 0x0F);               //interrupt on ps2 AND PS1 measurement
           pulse.setReg(PulsePlug::MEAS_RATE, 0x84);               //see datasheet -- every 10ms
         //pulse.setReg(PulsePlug::MEAS_RATE, 0x08);               //every 100ms
          pulse.setReg(PulsePlug::ALS_RATE, 0x08);                 //see datasheet ---- one measurement
          pulse.setReg(PulsePlug::PS_RATE, 0x08);                  //see datasheet --every time the device wakes up
         
         //Current setting for LEDs pulsed while taking readings
         //PS_LED21  Setting for LEDs 1 & 2. LED 2 is high nibble
         //each LED has 16 possible (0-F in hex) possible settings
         
         //pulse.setReg(PulsePlug::PS_LED21, 0x38);                //LED current for 2 (IR1 - high nibble) & LEDs 1 (red - low nibble)
         //pulse.setReg(PulsePlug::PS_LED21, 0x00);                //this powers off the green leds of the ID107HR
         //pulse.setReg(PulsePlug::PS_LED21, 0x11);
           pulse.setReg(PulsePlug::PS_LED3, 0x02);
           pulse.setReg(PulsePlug::PS_LED21, 0x00);                //this powers off the green leds of the ID107HR
         
         //Serial.print( "PS_LED21 = ");
         //Serial.println(pulse.getReg(PulsePlug::PS_LED21), BIN);
         //Serial.print("CHLIST = ");
         //Serial.println(pulse.readParam(0x01), BIN);
         
         pulse.writeParam(PulsePlug::PARAM_CH_LIST, 0x77);         //all measurements on
         
         //increasing PARAM_PS_ADC_GAIN will increase the LED on time and ADC window
         //you will see increase in brightness of visible LED's, ADC output, & noise
         //datasheet warns not to go beyond 4 because chip or LEDs may be damaged
         
         pulse.writeParam(PulsePlug::PARAM_PS_ADC_GAIN, 0x00);
         
         //You can select which LEDs are energized for each reading.
         //The settings below turn on only the LED that "normally" would be read
         //ie LED1 is pulsed and read first, then LED2 is pulsed and read etc.
         
         pulse.writeParam(PulsePlug::PARAM_PSLED12_SELECT, 0x21);          //21 = LED 2 & LED 1 (red) resp.
         
         //JJ there is no led 3 pulse.writeParam(PulsePlug::PARAM_PSLED3_SELECT, 0x04);   //4 = LED 3 only

         //Sensors for reading the three LEDs
         //0x03: Large IR Photodiode
         //0x02: Visible Photodiode - cannot be read with LEDs on - just for ambient measurement
         //0x00: Small IR Photodiode
         
         pulse.writeParam(PulsePlug::PARAM_PS1_ADCMUX, 0x03);              //PS1 photodiode select
                                                                           
         pulse.writeParam(PulsePlug::PARAM_PS2_ADCMUX, 0x03);              //PS2 photodiode select
                                                                           
         pulse.writeParam(PulsePlug::PARAM_PS3_ADCMUX, 0x03);              //PS3 photodiode select
         
         pulse.writeParam(PulsePlug::PARAM_PS_ADC_COUNTER, B01110000);     //B01110000 is default
                                                                           
         pulse.setReg(PulsePlug::COMMAND, PulsePlug::PSALS_AUTO_Cmd);      //starts an autonomous read loop
         
         //Serial.println(pulse.getReg(PulsePlug::CHIP_STAT), HEX);
         //Serial.print("end init");
}

